Subject: SENSE> What SENSE technology should be put inside a printer?

From: "[email-masked]" <[email-masked]>
Date: 13 Feb 97 10:44:12 -0800

After reading the exchange between Harry Lewis and Jeff Schnitzer, I'm 
starting to think that there might be a very, VERY cheap way to provide 
SENSE-able features within (ie, embedded into) a printer. 
 
For those present at my SENSE presentation last week, recall my description 
of Lexmark's simple Intervention Required (IR) mechanism that allows for 
simple printer condition/status via TCP.  Briefly, the IR mechanism is such 
that a mgmt app can connect to a well-known TCP port on the printer, after 
which the printer transmits simple lines containing two-digit strings that 
describe the current state (ie, mostly alert-like conditions).  (There's a 
bit more that goes on here, such as a simple acknowledgement from the mgmt 
app, but I'll leave that out for now). 
 
Now, what we can do with regard to SENSE is to devise a similar simpleton 
kind of technique, where the printer issues a STEP.1-formatted line of text 
describing an event condition.  Recall that this format is essentially: 
 
	nnn text... 
 
Where "nnn" is a specially encoded decimal digit string describing a 
combination of (in this order, left-to-right) "support level", "health" 
and "activity".  For example: 
 
	342 Tray 1 has been removed 
 
(I don't have the STEP.1 condition code table in front of me, so the above 
numeric condition value may not be correct for this type of alert condition.) 
 
The printer's connection management strategy could be the same as Lexmark's 
IR mechanism where the printer just sits there and handles in-bound 
connections to some well-known port, etc.  How many simultaneous connections 
would be implementation-specific, just as in any TCP-based service. 
 
Would printer vendors be willing to implement this simple method?  If so, 
then I can tell you right now that Underscore's reference implementation of 
the SENSE Framework can plug-in support for that vendor RIGHT NOW. 
 
Comments? (Particularly from printer vendors!) 
 
	...jay 

Subject: Re: SENSE> Re:Where to go with SENSE
From: "Jeff Schnitzer <[email-masked]>" <[email-masked]>
To: Harry,Lewis,<[email-masked]>
Cc: [email-masked],[email-masked]
Date: 13 Feb 97 08:56:48

> Let me get this straight. A STEP.1 publisher would not need to 
> implement the SENSE message format. Just the Text Event Protocol 
> itself and this is designed to work with standard networking
> protocols. Right?
> 
> Can I ask, how would a STEP.1 publisher communicate with a SENSE 
> server?  Could it be via a telnet session? Is there a preferred
> method?

No, STEP.1 describes a protocol data format that is encapsulated in 
the opaque data field of the SENSE message format.  A property in 
the encapsulating message would describe the data as a STEP.1 event.  

A STEP.1 Publisher communicates with the SENSE Server using the Common
SENSE protocol, where STEP.1 is the format of the opaque data in the
event message.  See FTP://ftp.pwg.org/pub/pwgsense/msgfmt.ps

Recall the Publication/Edition model of SENSE:  A Publication
is registered to describe the printer; an Edition is registered 
to represent the STEP.1 event stream.  A STEP.1 Publisher then
issues events for that Edition.  The SENSE Server then distributes
these events to interested Subscribers.  

Initial registration of this Publication and Edition might be
handled by a STEP.1 Publisher embedded in the printer, or it might
be delegated to external software.  If you wanted the printer
to work as automagically as possible, the embedded Publisher
would handle the registration as needed after determining the
appropriate SENSE domain and locating the SENSE Server.

Hmm, what we've been calling STEP.1 is called STEP.SingleLine.CC
in FTP://ftp.pwg.org/pub/pwg/sense/snsapx.htm#editions

/Jeff

---------------------------------------------------------------
Jeffrey D. Schnitzer      |   Email:  [email-masked] 
Underscore, Inc.          |   Voice:  (603) 889-7000
41-C Sagamore Park Rd     |     Fax:  (603) 889-2699   
Hudson, NH  03051-4915    |     Web:  http://www.underscore.com
---------------------------------------------------------------